
#include <algorithm>
#include <iostream>
#include <string>
#include <vector>

#include <RCF/RcfServer.hpp>
#include <RCF/TcpEndpoint.hpp>

#include "MyService.hpp"

class MyServiceImpl
{
public:
    void reverse(std::vector<std::string> &v)
    {
        std::cout << "Reversing a vector of strings...\n";
        std::vector<std::string> w;
        std::copy(v.rbegin(), v.rend(), std::back_inserter(w));
        v.swap(w);
    }
};

int main()
{
    MyServiceImpl myServiceImpl;
    RCF::RcfServer server(RCF::TcpEndpoint("0.0.0.0", 50001));
    server.bind<MyService>(myServiceImpl);
    server.start();
    server.waitForStopEvent();
    return 0;
}
