
//******************************************************************************
// RCF - Remote Call Framework
// Copyright (c) 2005 - 2008, Jarl Lindrud. All rights reserved.
// Consult your license for conditions of use.
// Version: 1.0
// Contact: jarl.lindrud <at> gmail.com 
//******************************************************************************

#ifndef INCLUDE_RCF_TCPCLIENTTRANSPORT_HPP
#define INCLUDE_RCF_TCPCLIENTTRANSPORT_HPP

#include <RCF/BsdClientTransport.hpp>
#include <RCF/Export.hpp>
#include <RCF/IpClientTransport.hpp>

namespace RCF {

    class RCF_EXPORT TcpClientTransport : 
        public BsdClientTransport, 
        public I_IpClientTransport
    {
    public:
        TcpClientTransport(const TcpClientTransport &rhs);
        TcpClientTransport(const std::string &ip, int port);
        TcpClientTransport(const sockaddr_in &remoteAddr);
        TcpClientTransport(int fd);

        ~TcpClientTransport();

        ClientTransportAutoPtr clone() const;

        // I_IpClientTransport
        int                     getSocket();

        void                    implConnect(unsigned int timeoutMs);
        void                    implClose();
        EndpointPtr             getEndpointPtr() const;

        void                    setRemoteAddr(const sockaddr_in &remoteAddr);
        const sockaddr_in &     getRemoteAddr() const;

    private:

        sockaddr_in             mRemoteAddr;
        std::string             mIp;
        int                     mPort;
    };

} // namespace RCF

#endif // ! INCLUDE_RCF_TCPCLIENTTRANSPORT_HPP
