
//******************************************************************************
// RCF - Remote Call Framework
// Copyright (c) 2005 - 2008, Jarl Lindrud. All rights reserved.
// Consult your license for conditions of use.
// Version: 1.0
// Contact: jarl.lindrud <at> gmail.com 
//******************************************************************************

#ifndef INCLUDE_RCF_TEST_TESTMINIMAL_HPP
#define INCLUDE_RCF_TEST_TESTMINIMAL_HPP

#if (__BORLANDC__ >= 0x560) && defined(_USE_OLD_RW_STL)

int failures = 0;

#define BOOST_CHECK(arg) if (arg); else ++failures;

namespace boost { static const int exit_success = 0; }

int test_main(int argc, char **argv);

int main(int argc, char **argv)
{
    return test_main(argc, argv) + failures;
}

extern "C" void tss_cleanup_implemented(void)
{}

#else

#ifdef _MSC_VER
#pragma warning( disable : 4701 4535 )
#endif

// Include valarray early so it doesn't get trampled by min/max macro definitions.
#if defined(_MSC_VER) && _MSC_VER == 1310 && defined(RCF_USE_BOOST_SERIALIZATION)
#include <valarray>
#endif

#include <boost/test/minimal.hpp>

#ifdef _MSC_VER
#pragma warning( default : 4701 4535 )
#endif

#endif

#include <RCF/test/PrintTestHeader.hpp>
#include <RCF/test/ProgramTimeLimit.hpp>
#include <RCF/test/SpCollector.hpp>
#include <RCF/util/Platform/OS/Sleep.hpp>
#include <RCF/util/TraceCommandLineOption.hpp>
#include <RCF/test/DisableGpfDialog.hpp>

#endif // ! INCLUDE_RCF_TEST_TESTMINIMAL_HPP
