
//******************************************************************************
// RCF - Remote Call Framework
// Copyright (c) 2005 - 2008, Jarl Lindrud. All rights reserved.
// Consult your license for conditions of use.
// Version: 1.0
// Contact: jarl.lindrud <at> gmail.com 
//******************************************************************************

#ifndef INCLUDE_UTIL_PLATFORM_OS_UNIX_THREADID_HPP
#define INCLUDE_UTIL_PLATFORM_OS_UNIX_THREADID_HPP

#include <boost/config.hpp>

#ifdef BOOST_HAS_PTHREADS
#include <pthread.h>
#endif

namespace Platform {

    namespace OS {

#ifdef BOOST_HAS_PTHREADS

#if defined(__CYGWIN__)
        inline int GetCurrentThreadId() { return reinterpret_cast<int>(static_cast<void*>(pthread_self())); }
#elif defined(__MACH__) && defined(__APPLE__)
        inline int GetCurrentThreadId() { return reinterpret_cast<int>(static_cast<void*>(pthread_self())); }
#elif defined(__FreeBSD__) || defined(__OpenBSD__) || defined(__NetBSD__)
        inline int GetCurrentThreadId() { return reinterpret_cast<int>(static_cast<void*>(pthread_self())); }
#else
        inline int GetCurrentThreadId() { return static_cast<int>(pthread_self()); }
#endif

#else
        inline int GetCurrentThreadId() { return 0; }
#endif

    }
}

#endif // ! INCLUDE_UTIL_PLATFORM_OS_UNIX_THREADID_HPP
