
//******************************************************************************
// RCF - Remote Call Framework
// Copyright (c) 2005 - 2008, Jarl Lindrud. All rights reserved.
// Consult your license for conditions of use.
// Version: 1.0
// Contact: jarl.lindrud <at> gmail.com 
//******************************************************************************

#include <RCF/ClientTransport.hpp>
#include <RCF/ServerTransport.hpp>

namespace RCF {

    I_ClientTransport::I_ClientTransport() :
        mMaxMessageLength(getDefaultMaxMessageLength())
    {}

    bool I_ClientTransport::isConnected()
    {
        return true;
    }

    void I_ClientTransport::setMaxMessageLength(std::size_t maxMessageLength)
    {
        mMaxMessageLength = maxMessageLength;
    }

    std::size_t I_ClientTransport::getMaxMessageLength() const
    {
        return mMaxMessageLength;
    }

} // namespace RCF
